
c
c	Copyright (c) 1986,1987,1988,1989,1990,1991,1992,1993,
c       by Steve McMillan, Drexel University, Philadelphia, PA.
c
c       All rights reserved.
c
c	Redistribution and use in source and binary forms are permitted
c	provided that the above copyright notice and this paragraph are
c	duplicated in all such forms and that any documentation,
c	advertising materials, and other materials related to such
c	distribution and use acknowledge that the software was developed
c	by the author named above.
c
c	THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
c	IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
c	WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
c
        
        subroutine fr lnydr(x,y1,y2,dys,dym,dyl,iax,ilab,nlab,ndec)
        save
c       
c       As for lnxdr, but for the y-axis
c       
c       N.B. Variable "ilab" is redundant, now.
c       
        character*80 device
        common/plot device/device,aspect,idev
        dimension dy(3)
        common/scales/xl,xr,dinchx,ybot,ytop,dinchy,rlen,slen
        common/dev status/idevon,idevpen,idevwt
        common/fr hts/htl,htn/fr wts/iwts(4)/fr rotn/irot
        common/fr ticks/tiks(3),tikl/fr int/iframe
        common/fr conf/scent,rnuml,rnumr,snumt,snumb,dsnums,jrot,stopnum
        common/fr tik level/jtik level
        common/fr bare/ibare
        common/fontc1/dum2(5),rrmax,rrmin,ssmax,ssmin
        common/fr setax/kax,lax
        character*50 outstr
c       
        common/fr lby/lmode
        data mode/1/
c
        data theta/90./thetal/0./
c       
        cinch(xa,xs,di)=(xa-xs)*di
c       
        if (lax.lt.0) return
c       
        dy(1)=dys
        dy(2)=dym
        dy(3)=dyl
        rax=cinch(x,xl,dinchx)
        s1=cinch(y1,ybot,dinchy)
        s2=cinch(y2,ybot,dinchy)
        if(iwts(1).gt.0)then
            jwt=idevwt
            call weight(iwts(1))
        end if
        call plot(rax,s1,3)
        call plot(rax,s2,2)
c       
        if (lax.eq.1.and.iax.eq.2) return
        if (lax.eq.2.and.iax.eq.1) return
c       
c       Now draw tick marks.
c       
        dr=1.
        if(iax.eq.2) dr=-1.
        do 2 j=jtik level,3
            if(dy(j).eq.0.) go to 2
            rtik=rax+dr*tiks(j)
            call fr lnfnc(y1,y2,dy(j),mode,firsty,ny)
            ds=dy(j)*dinchy
            s=cinch(firsty,ybot,dinchy)
            do 1 i=1,ny
                call plot(rax,s,3)
                call plot(rtik,s,2)
                s=s+ds
1           continue
2       continue
        if(iwts(1).gt.0)call weight(jwt)
        jrot=irot
c       
        if (lmode.ne.0) return
        if (lax.eq.0.and.iax.eq.2) return
        if (lax.eq.3.and.iax.eq.1) return
c       
c       Numeric labels are also desired:
c       
        dsnums=ds
c       
c       Get actual length of the numbers.
c       
        if(ibare.eq.1)then
            if(ndec.ne.0)then
                nnum=0
                if(firsty.lt.0.)nnum=1
                if(ndec.gt.0)nnum=nnum+ndec
                mm=0
                do 90 k=1,ny
                    y=firsty+(k-1.)*dyl
                    if(abs(y).lt.1.)then
                        nn=1
                    else
                        nn=log10(abs(y))+1
                    end if
                    if(nn.gt.mm)mm=nn
90              continue
                nnum=nnum+mm
                xlnum=htn*(nnum+.5)
            else
                xlnum=2.*htn
                mm=0
                do 100 k=1,ny
                    y=firsty+(k-1.)*dyl
                    nn=0
                    if(y.lt.0.)nn=1
                    if(abs(y).ge.1.)nn=nn+1+log10(abs(y))
                    mm=max(mm,nn)
100             continue
                xlnum=xlnum+.5333*mm*htn
            end if
        else
            if(ndec.ne.0)then
                xlnum=0.
                do 110 k=1,ny
                    y=firsty+(k-1.)*dyl
                    call numsym(y,ndec,outstr,m)
                    call simbol(0.,0.,-htn,outstr,0.,m)
                    xlnum=max(xlnum,rrmax-rrmin)
                    if(idev.eq.7.or.idev.eq.8)xlnum=1.1*xlnum
110             continue
            else
                call simbol(0.,0.,-htn,'10',0.,2)
                xlnum=rrmax-rrmin
                xx=0.
                do 120 k=1,ny
                    y=firsty+(k-1.)*dyl
                    call numsym(y,-1,outstr,m)
                    call simbol(0.,0.,-htn,outstr,0.,m)
                    xx=max(xx,rrmax-rrmin)
120             continue
                xlnum=1.1*(xlnum+.5333*xx)
                if(idev.eq.7.or.idev.eq.8)xlnum=1.1*xlnum
            end if
        end if
        dsnum=1.5*htn
        if(jrot.ne.0)dsnum=1.3*xlnum
c       
c       Now the numeric labels are xlnum wide, dsnum tall.
c       
130     if(dsnum.gt.ds)then
c           
c           Label is too tall.
c           
            fac=ds/dsnum
            if(jrot.ne.0.and.fac.lt..4)then
                jrot=0
                dsnum=1.5*htn
                go to 130
            end if
            htn=htn*fac
            xlnum=xlnum*fac
            dsnum=ds
        end if
c       
        if (iax.eq.1) then
            call getlhe(space)
            space=-space-htl
        else
            call getrhe(space)
            space = space - x - htl
        end if
c       
        if(space.gt.0.and.jrot.eq.0.and.xlnum.gt..9*space)then
c           
c           Too wide...
c           
            htn=htn*.9*space/xlnum
            xlnum=.9*space
        end if
c       
        y=firsty
        s1=cinch(firsty,ybot,dinchy)
        half=.5*htn
        strlen=xlnum
        strlen2=.5*strlen
        call pushstr
        if(jrot.eq.0)then
            th=thetal
            if(ndec.ne.0)then
                if (iax.eq.1) then
                    call strpos(1.,.5)
                    r=rax-half
                    s=s1
                else
                    call strpos(0.,.5)
                    r = rax+half
                    s=s1
                end if
            else
                if(ndec.ne.0)iframe=0
                if(iax.eq.1)r=rax-strlen-.5*htn
                if(iax.eq.2)r=rax+half
                s=s1-half
            end if
        else
            th=theta
            if(iax.eq.1)r=rax-htn
            if(iax.eq.2)r=rax+htn
            s=s1
        end if
        smin=half               ! only o ffset first y-axis
        if(th.eq.theta)smin=strlen2 ! label if it really would
        if(s1.lt.smin)s=s+smin  ! extend below the x-axis.
        if(iwts(2).gt.0)then
            jwt=idevwt
            call weight(iwts(2))
        end if
c       
        if (iax.eq.2) th = -th
c       
        if(ndec.eq.0)then
            call lognum(r,s,htn,y,th,-1)
            rnummin=r
        else
            call fr numbr(r,s,htn,y,th,ndec)
            rnummin=rrmin
        end if
        rnummax = rnummin + xlnum
c       
        snumb=0.
        snumt=slen
        rnuml=0.
        rnumr = 0.
        inumset=0
        sref=s
        if(jrot.eq.0.and.ndec.ne.0)sref=sref-half
        if(ndec.ne.0.and.(jrot.ne.0))
     +          sref=sref-strlen2
c       
c       sref is the level of the bottom of the current numerical label.
c       
        if(sref.le.scent.and.sref+ds.gt.scent)then
            inumset=1
            snumt=sref+ds
            if(jrot.ne.0)then
                rnuml=r-htn
                rnumr=r+htn
                snumb=s+strlen2
            else
                if(ndec.eq.0)then
                    rnuml=r
                    rnumr = r+strlen
                    snumb=s+1.2*htn
                else
                    rnuml=r-strlen
                    rnumr = r
                    snumb=sref+htn
                end if
            end if
        end if
c       
        if(s1.lt.smin)s=s-smin
        if(ny.le.1)go to 4
        do 3 i=2,ny
            s=s+ds
            y=y+dyl
c           
            if(ndec.eq.0)then
                call lognum(r,s,htn,y,th,-1)
                rnummin=min(rnummin,r)
                rnummax=max(rnummax,r+strlen)
            else
                call fr numbr(r,s,htn,y,th,ndec)
                rnummin=min(rnummin,rrmin)
                rnummax=max(rnummax,rrmax)
            end if
c           
            if(inumset.eq.0)then
                sref=s
                if(jrot.eq.0.and.ndec.ne.0)sref=sref-half
                if(sref.le.scent.and.sref+ds.gt.scent)then
                    inumset=1
                    snumt=sref+ds
                    if(jrot.ne.0)then
                        rnuml=r-htn
                        rnumr=r+htn
                        snumb=s+strlen2
                    else
                        if(ndec.eq.0)then
                            rnuml=r
                            rnumr = r+strlen
                            snumb=s+1.2*htn
                        else
                            rnuml=r-strlen
                            rnumr = r
                            snumb=sref+htn
                        end if
                    end if
                end if
            end if
3       continue
4       if(iwts(2).gt.0)call weight(jwt)
        iframe=1
        call popstr
c       
        rnuml=rnummin
        rnumr = max(rnummax,rnuml+htn*jrot+strlen*(1-jrot))
c       
        snumb=max(0.,snumb)
        snumt=min(slen,snumt)
        stopnum=s
c       
        end
