#include "stdinc.h"

//// runtime_help:  test Starlab run-time help function
////
//// Options:       -help     print this message

#ifndef TOOLBOX

void get_runtime_help(char* source_file, int level)
{
    char cmd[1024];

    // Assume that help lines begin with "//// " (level 1)
    // or "//++ " (level 2).

    // First, find and print out level-1 help lines.

    strcpy(cmd, "grep '^////' ");
    strcat(cmd, source_file);
    strcat(cmd, " | sed s%////%\"   \"%");

    cout << "    (" << source_file << ")\n\n";

    system(cmd);
    cout<< endl;

    // Now check for level-2 help.

    if (level > 1) {
	strcpy(cmd, "grep '^//++' ");
	strcat(cmd, source_file);
	strcat(cmd, " | sed s%//++%\"    + \"%");

	system(cmd);
	cout<< endl;
    }

    exit(0);
}

void check_runtime_help(int argc, char** argv, char* source_file)
{
    int help_level = 0;

    for (int i = 1; i < argc; i++) {
	if (strstr(argv[i], "-help")) help_level++;
	if (strstr(argv[i], "-HELP")) help_level = 2;
    }

    if (help_level) get_runtime_help(source_file, help_level);
}

#else

main(int argc, char** argv)
{
    check_help();
}

#endif
