/*
 *  rmtree.C: recursively deletes a node together with all of its offspring
 *.............................................................................
 *    version 1:  Nov 1994   Piet Hut
 *.............................................................................
 */
#include "node.h"

void rmtree(node* b)
{
    node* d = b->get_oldest_daughter();
    while (d) {
	node* tmp = d->get_younger_sister();
	rmtree(d);
	d = tmp;
    }
    delete b;
}

/* endof: rmtree.c */
