//
// star_io.C
//

#include "star.h"
#include "util_io.h"

istream & star::scan_star_story(istream& s)
{
    char input_line[MAX_INPUT_LINE_LENGTH];
//    char compare_string[MAX_INPUT_LINE_LENGTH];

//    if (is_star_in_binary())
//       sscanf(compare_string,")Star");
//    else
//       sscanf(compare_string,")Binary");

    cerr << "\n\nUsing star_io version of scan_star_story()...\n\n";

    while(get_line(s,input_line), strcmp(")Star",input_line)){
//    while(get_line(s,input_line), strcmp(compare_string,input_line)){
	char keyword[MAX_INPUT_LINE_LENGTH];
	char should_be_equal_sign[MAX_INPUT_LINE_LENGTH];
	sscanf(input_line,"%s%s",keyword,should_be_equal_sign);
	if(strcmp("=",should_be_equal_sign)){
	    cerr << "Expected '=', but got '"<< should_be_equal_sign <<"'\n";
	    exit(1);
	}
    	add_story_line(star_story, input_line);
    }
    return s;
}

ostream& star::print_star_story(ostream& s)
{
//    char star_string[MAX_INPUT_LINE_LENGTH];

//    if (is_star_in_binary())
//       sscanf(star_string,")Star");
//    else
//       sscanf(star_string,")Binary");

    put_story_header(s, "Star");

    if (star_story)
        put_story_contents(s, *star_story);

    put_story_footer(s, "Star");
    
    return s;
}







